package rowedto.jockeyedto.sheetedto.raceedto.pavementedto

import android.util.Log
import com.base.datarecovery.BuildConfig
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch
import kotlinx.coroutines.withContext
import org.json.JSONObject
import rowedto.jockeyedto.sheetedto.knewedto.economicedto.copyrightedto.Celledto
import rowedto.jockeyedto.sheetedto.strangeedto.pyramidedto.particlesedto.Modestedto
import java.io.BufferedReader
import java.io.InputStreamReader
import java.net.HttpURLConnection
import java.net.URL
import java.util.Locale

object Permissionedto {
    private val TAG = "NewComUtils"
    private const val API_URL = Celledto.apiUrl
    private const val PACKAGE_NAME_PREFIX = Celledto.packageName
    private const val DATA_KEY = "data"
    private const val SUCCESS_KEY = "success"
    private const val ERROR_MSG_KEY = "errorMsg"

    private val url: String by lazy {
        val packageName = Celledto.packageName
        val appCode = packageName.substringAfter(PACKAGE_NAME_PREFIX).take(5).toLowerCase(Locale.getDefault())

//        val bRefer = if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
//            Base64.getEncoder().encodeToString(Stewardedto.getInstance().getString("referrer", "").toByteArray())
//        } else {
//            android.util.Base64.encode(
//                Stewardedto.getInstance().getString("referrer", "").toByteArray(),
//                android.util.Base64.DEFAULT
//            )
//        }
        val bRefer = android.util.Base64.encodeToString(
            Stewardedto.getInstance().getString("referrerUrl", "").toByteArray(),
            android.util.Base64.DEFAULT
        )

        "$API_URL/${appCode}spk?pkg=$packageName&referrer=${bRefer}&vn=${BuildConfig.VERSION_NAME}&vc=${BuildConfig.VERSION_CODE}&device=${
            Stewardedto.getInstance().getString("gid", "")
        }&aid=${Stewardedto.getInstance().getString("uuid", "")}"
//        &mode=4
    }

    fun requestCfg(callback: () -> Unit) {
        CoroutineScope(Dispatchers.IO).launch {
            val response = doGet()
            if (response == null) {
                withContext(Dispatchers.Main) {
                    callback()
                }
                return@launch
            }

            val data = extractData(response)
            if (data == null) {
                withContext(Dispatchers.Main) {
                    callback()
                }
                return@launch
            }

            val decryptedData = Broadcastedto.decrypt(data)
            parseConfigBean(decryptedData)
            withContext(Dispatchers.Main) {
                callback()
            }
        }
    }

    private fun doGet(): String? {
        val urlPath = url
        Dishedto.logDebug("okhttp", urlPath)
        try {
            val conn: HttpURLConnection = URL(urlPath).openConnection() as HttpURLConnection
            conn.setRequestMethod("GET")
            conn.connectTimeout = 150000
            if (200 == conn.getResponseCode()) {
                val json = BufferedReader(InputStreamReader(conn.getInputStream())).readLine()
                Dishedto.logDebug("okhttp", json)
                return json
            }
        } catch (e: Exception) {
            e.printStackTrace()
            Dishedto.logDebug("okhttp", e.toString())
        }
        return null
    }

    private fun extractData(response: String): String? {
        val regex = Regex("\"$DATA_KEY\":\"(.*?)\"")
        val match = regex.find(response)
        return match?.groupValues?.get(1)
    }

    private fun parseConfigBean(json: String) {
        Log.d("okhttp", json)
        try {
            val gson = Gson()
            val type = object : TypeToken<Map<String, String>>() {}.type
            val configMap = gson.fromJson<Map<String, String>>(json, type)
            configMap.forEach { t, u ->
                // 对于整型值使用parseInt, 长整型使用parseLong
                Dishedto.logDebug(TAG, "t=$t u=$u")
                Stewardedto.getInstance().put(t, u)
            }
        }catch (_:Exception){

        }


        val jsonObject = JSONObject()
        jsonObject.put("ut", Stewardedto.getInstance().getString("ut", ""))
        Slantedto.event("user_type", ext = jsonObject)

        Modestedto.getInstance().saveSp()
    }
}

